Debian Bug report logs - #730662
wget: fails to parse time from 'Last-Modified: Wed, 27 Nov 2013 07:06:38 UTC'

version graph

Package: wget; Maintainer for wget is Noël Köthe <noel@debian.org>; Source for wget is src:wget.

Reported by: Andreas Beckmann <anbe@debian.org>

Date: Wed, 27 Nov 2013 23:06:02 UTC

Severity: normal

Tags: patch, upstream

Found in version wget/1.13.4-3

Done: Noël Köthe <noel@debian.org>

Bug is archived. No further changes may be made.

Forwarded to https://savannah.gnu.org/bugs/index.php?40746

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Noël Köthe <noel@debian.org>:
Bug#730662; Package wget. (Wed, 27 Nov 2013 23:06:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Andreas Beckmann <anbe@debian.org>:
New Bug report received and forwarded. Copy sent to Noël Köthe <noel@debian.org>. (Wed, 27 Nov 2013 23:06:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Andreas Beckmann <anbe@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: wget: fails to parse time from 'Last-Modified: Wed, 27 Nov 2013 07:06:38 UTC'
Date: Thu, 28 Nov 2013 00:03:28 +0100
Package: wget
Version: 1.13.4-3
Severity: normal
Tags: upstream

Hi,

wget does not parse Last-Modified timestamps in the UTC timezone,
resulting in error output
  Last-modified header invalid -- time-stamp ignored.
and assigning all downloaded files the current timestamp - which is a
loss of metadata.
The problem occurs in versions 1.13.4-3, 1.14-5, 1.14.96.38327-2.

These timestamps with a UTC instead of GMT timezone seem to be generated
by a (transparent) proxy that identifies itself with this header:
  Via: 1.1 xxxxx.xxxxx.xx:80 (Cisco-IronPort-WSA/7.7.0-608)

The patch is trivial, in src/http.c in check_end() the following clause
needs to be added:

  || (p[0] == 'U' && p[1] == 'T' && p[2] == 'C')

(tested against the version in experimental)


Andreas



Information forwarded to debian-bugs-dist@lists.debian.org, Noël Köthe <noel@debian.org>:
Bug#730662; Package wget. (Fri, 29 Nov 2013 09:03:14 GMT) Full text and rfc822 format available.

Acknowledgement sent to NoëlKöthe <INVALID.NOREPLY@gnu.org>:
Extra info received and forwarded to list. Copy sent to Noël Köthe <noel@debian.org>. (Fri, 29 Nov 2013 09:03:14 GMT) Full text and rfc822 format available.

Message #10 received at 730662@bugs.debian.org (full text, mbox):

From: NoëlKöthe <INVALID.NOREPLY@gnu.org>
To: NoëlKöthe <noel@debian.org>, 730662@bugs.debian.org, gscrivano@gnu.org
Subject: [bug #40746] wget: fails to parse time from 'Last-Modified: Wed, 27 Nov 2013 07:06:38 UTC'
Date: Fri, 29 Nov 2013 08:59:02 +0000
URL:
  <http://savannah.gnu.org/bugs/?40746>

                 Summary: wget: fails to parse time from 'Last-Modified: Wed,
27 Nov 2013 07:06:38 UTC'
                 Project: GNU Wget
            Submitted by: nok
            Submitted on: Fr 29 Nov 2013 09:59:00 CET
                Category: Protocol Issue
                Severity: 3 - Normal
                Priority: 5 - Normal
                  Status: None
                 Privacy: Public
             Assigned to: None
         Originator Name: 
        Originator Email: 
             Open/Closed: Open
         Discussion Lock: Any
                 Release: trunk
        Operating System: GNU/Linux
         Reproducibility: Every Time
           Fixed Release: None
         Planned Release: None
              Regression: None
           Work Required: None
          Patch Included: Yes

    _______________________________________________________

Details:

Hello,

a forwarded Debian bug report from http://bugs.debian.org/730662

--8<--
wget does not parse Last-Modified timestamps in the UTC timezone,
resulting in error output
  Last-modified header invalid -- time-stamp ignored.
and assigning all downloaded files the current timestamp - which is a loss of
metadata.
The problem occurs in versions 1.13.4-3, 1.14-5, 1.14.96.38327-2.

These timestamps with a UTC instead of GMT timezone seem to be generated by a
(transparent) proxy that identifies itself with this header:
  Via: 1.1 xxxxx.xxxxx.xx:80 (Cisco-IronPort-WSA/7.7.0-608)

The patch is trivial, in src/http.c in check_end() the following clause needs
to be added:

  || (p[0] == 'U' && p[1] == 'T' && p[2] == 'C')

(tested against the version in experimental)


Andreas
--8<--

Thanks for your work.

Regards

Noël




    _______________________________________________________

Reply to this item at:

  <http://savannah.gnu.org/bugs/?40746>

_______________________________________________
  Nachricht gesendet von/durch Savannah
  http://savannah.gnu.org/




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#730662; Package wget. (Fri, 29 Nov 2013 09:05:16 GMT) Full text and rfc822 format available.

Acknowledgement sent to Noël Köthe <noel@debian.org>:
Extra info received and forwarded to list. (Fri, 29 Nov 2013 09:05:16 GMT) Full text and rfc822 format available.

Message #15 received at 730662@bugs.debian.org (full text, mbox):

From: Noël Köthe <noel@debian.org>
To: Andreas Beckmann <anbe@debian.org>, 730662@bugs.debian.org
Cc: control <control@bugs.debian.org>
Subject: Re: Bug#730662: wget: fails to parse time from 'Last-Modified: Wed, 27 Nov 2013 07:06:38 UTC'
Date: Fri, 29 Nov 2013 10:03:21 +0100
[Message part 1 (text/plain, inline)]
forwarded 730662 https://savannah.gnu.org/bugs/index.php?40746
tags 730662 + patch
thanks

Hello Andreas,

Am Donnerstag, den 28.11.2013, 00:03 +0100 schrieb Andreas Beckmann:

> wget does not parse Last-Modified timestamps in the UTC timezone,
> resulting in error output
>   Last-modified header invalid -- time-stamp ignored.
> and assigning all downloaded files the current timestamp - which is a
> loss of metadata.
> The problem occurs in versions 1.13.4-3, 1.14-5, 1.14.96.38327-2.
> 
> These timestamps with a UTC instead of GMT timezone seem to be generated
> by a (transparent) proxy that identifies itself with this header:
>   Via: 1.1 xxxxx.xxxxx.xx:80 (Cisco-IronPort-WSA/7.7.0-608)
> 
> The patch is trivial, in src/http.c in check_end() the following clause
> needs to be added:
> 
>   || (p[0] == 'U' && p[1] == 'T' && p[2] == 'C')
> 
> (tested against the version in experimental)

Thanks for your report and patch. I forwarded it upstream and hopefully
it will be included in the next upstream release.

Regards

	Noël
[signature.asc (application/pgp-signature, inline)]

Set Bug forwarded-to-address to 'https://savannah.gnu.org/bugs/index.php?40746'. Request was from Noël Köthe <noel@debian.org> to control@bugs.debian.org. (Fri, 29 Nov 2013 09:05:19 GMT) Full text and rfc822 format available.

Added tag(s) patch. Request was from Noël Köthe <noel@debian.org> to control@bugs.debian.org. (Fri, 29 Nov 2013 09:05:20 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Noël Köthe <noel@debian.org>:
Bug#730662; Package wget. (Mon, 16 Dec 2013 11:57:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Ruehsen <INVALID.NOREPLY@gnu.org>:
Extra info received and forwarded to list. Copy sent to Noël Köthe <noel@debian.org>. (Mon, 16 Dec 2013 11:57:09 GMT) Full text and rfc822 format available.

Message #24 received at 730662@bugs.debian.org (full text, mbox):

From: Tim Ruehsen <INVALID.NOREPLY@gnu.org>
To: NoëlKöthe <noel@debian.org>, 730662@bugs.debian.org, Tim Ruehsen <tim.ruehsen@gmx.de>, gscrivano@gnu.org
Subject: [bug #40746] wget: fails to parse time from 'Last-Modified: Wed, 27 Nov 2013 07:06:38 UTC'
Date: Mon, 16 Dec 2013 11:55:07 +0000
Follow-up Comment #1, bug #40746 (project wget):

Just to mention it. The server is broken and does not behave RFC 2616
compliant.

from RFC 2616, 3.3.1 Full Date

...
This is indicated in the first two formats by the inclusion of "GMT" as the
three-letter abbreviation for time zone, and MUST be assumed when reading the
asctime format.
...
       HTTP-date    = rfc1123-date | rfc850-date | asctime-date
       rfc1123-date = wkday "," SP date1 SP time SP "GMT"
       rfc850-date  = weekday "," SP date2 SP time SP "GMT"
       asctime-date = wkday SP date3 SP time SP 4DIGIT

Therefore Wget should just ignore the timezone in rfc1123-date and rfc850-date
and always assume GMT/UTC.


    _______________________________________________________

Reply to this item at:

  <http://savannah.gnu.org/bugs/?40746>

_______________________________________________
  Message sent via/by Savannah
  http://savannah.gnu.org/




Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#730662; Package wget. (Mon, 20 Jan 2014 20:12:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Noël Köthe <noel@debian.org>:
Extra info received and forwarded to list. (Mon, 20 Jan 2014 20:12:04 GMT) Full text and rfc822 format available.

Message #29 received at 730662@bugs.debian.org (full text, mbox):

From: Noël Köthe <noel@debian.org>
To: Andreas Beckmann <anbe@debian.org>, 730662@bugs.debian.org
Subject: Re: Bug#730662: [bug #40746] wget: fails to parse time from 'Last-Modified: Wed, 27 Nov 2013 07:06:38 UTC'
Date: Mon, 20 Jan 2014 21:10:13 +0100
[Message part 1 (text/plain, inline)]
Hello Andreas,

sorry just saw you didn't got the answers to your report:
https://bugs.debian.org/730662

I will close it if you agree.

Am Montag, den 16.12.2013, 11:55 +0000 schrieb Tim Ruehsen:
> Follow-up Comment #1, bug #40746 (project wget):
> 
> Just to mention it. The server is broken and does not behave RFC 2616
> compliant.
> 
> from RFC 2616, 3.3.1 Full Date
> 
> ...
> This is indicated in the first two formats by the inclusion of "GMT" as the
> three-letter abbreviation for time zone, and MUST be assumed when reading the
> asctime format.
> ...
>        HTTP-date    = rfc1123-date | rfc850-date | asctime-date
>        rfc1123-date = wkday "," SP date1 SP time SP "GMT"
>        rfc850-date  = weekday "," SP date2 SP time SP "GMT"
>        asctime-date = wkday SP date3 SP time SP 4DIGIT
> 
> Therefore Wget should just ignore the timezone in rfc1123-date and rfc850-date
> and always assume GMT/UTC.
>
>     _______________________________________________________
> 
> Reply to this item at:
> 
>   <http://savannah.gnu.org/bugs/?40746>

Regards

	Noël
[signature.asc (application/pgp-signature, inline)]

Reply sent to Noël Köthe <noel@debian.org>:
You have taken responsibility. (Thu, 23 Jan 2014 10:03:10 GMT) Full text and rfc822 format available.

Notification sent to Andreas Beckmann <anbe@debian.org>:
Bug acknowledged by developer. (Thu, 23 Jan 2014 10:03:10 GMT) Full text and rfc822 format available.

Message #34 received at 730662-done@bugs.debian.org (full text, mbox):

From: Noël Köthe <noel@debian.org>
To: 730662-done@bugs.debian.org
Subject: Re: Bug#730662: [bug #40746] wget: fails to parse time from 'Last-Modified: Wed, 27 Nov 2013 07:06:38 UTC'
Date: Thu, 23 Jan 2014 10:58:39 +0100
[Message part 1 (text/plain, inline)]
Version: 1.13.4-3

> I will close it if you agree.

sorry, when I'm closing to fast but we can reopen it if needed.:)

> Am Montag, den 16.12.2013, 11:55 +0000 schrieb Tim Ruehsen:

> > Just to mention it. The server is broken and does not behave RFC 2616
> > compliant.

-- 
Noël Köthe <noel debian.org>
Debian GNU/Linux, www.debian.org
[signature.asc (application/pgp-signature, inline)]

No longer marked as fixed in versions 1.13.4-3. Request was from Andreas Beckmann <anbe@debian.org> to control@bugs.debian.org. (Wed, 29 Jan 2014 04:15:17 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 26 Feb 2014 07:32:41 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 14:28:34 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.